"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IDL = exports.RENDER_MINT = exports.MPL_BUBBLEGUM_PROGRAM_ID = exports.MPL_TOKEN_METADATA_PROGRAM_ID = exports.PROGRAM_ID = void 0;
const web3_js_1 = require("@solana/web3.js");
exports.PROGRAM_ID = new web3_js_1.PublicKey("remHV1Yd654Wvcc2C9jZedkBMBPJzJGpDWWQxrpBf2c");
exports.MPL_TOKEN_METADATA_PROGRAM_ID = new web3_js_1.PublicKey("metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s");
exports.MPL_BUBBLEGUM_PROGRAM_ID = new web3_js_1.PublicKey('BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY');
exports.RENDER_MINT = new web3_js_1.PublicKey("rndrizKT3MK1iimdxRdWabcF7Zg7AR5T4nud4EkHBof");
// TODO: anchor init chucks some error. maybe https://github.com/coral-xyz/anchor/issues/2679
// no idea
exports.IDL = {
    "version": "0.1.0",
    "name": "render_entity_manager",
    "instructions": [
        {
            "name": "initializeMakerV0",
            "accounts": [
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "maker",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "collection",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "associatedTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "collectionMetadata",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "collectionMasterEdition",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "associatedTokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenMetadataProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "args",
                    "type": {
                        "defined": "InitializeMakerArgsV0"
                    }
                }
            ]
        },
        {
            "name": "addTreeV0",
            "accounts": [
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "updateAuthority",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "maker",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "merkleTree",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "treeConfig",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "bubblegumProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "compressionProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "logWrapper",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "args",
                    "type": {
                        "defined": "AddTreeArgsV0"
                    }
                }
            ]
        },
        {
            "name": "createJobV0",
            "accounts": [
                {
                    "name": "issuingAuthority",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "userAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "maker",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "merkleTree",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "collection",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "collectionMetadata",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "treeConfig",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "bubblegumSigner",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "collectionMasterEdition",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenMetadataProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "logWrapper",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "bubblegumProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "compressionProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "args",
                    "type": {
                        "defined": "CreateJobArgsV0"
                    }
                }
            ]
        },
        {
            "name": "updateMakerV0",
            "accounts": [
                {
                    "name": "maker",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "updateAuthority",
                    "isMut": true,
                    "isSigner": true
                }
            ],
            "args": [
                {
                    "name": "args",
                    "type": {
                        "defined": "UpdateMakerArgsV0"
                    }
                }
            ]
        },
        {
            "name": "burnJobRenderV0",
            "accounts": [
                {
                    "name": "userAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "authority",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "renderMint",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "accountEscrow",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "args",
                    "type": {
                        "defined": "BurnJobRenderArgsV0"
                    }
                }
            ]
        },
        {
            "name": "initializeUserV0",
            "accounts": [
                {
                    "name": "userAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "accountEscrow",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "renderMint",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "authority",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "args",
                    "type": {
                        "defined": "InitializeUserArgsV0"
                    }
                }
            ]
        }
    ],
    "accounts": [
        {
            "name": "MakerV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "updateAuthority",
                        "type": "publicKey"
                    },
                    {
                        "name": "issuingAuthority",
                        "type": "publicKey"
                    },
                    {
                        "name": "name",
                        "type": "string"
                    },
                    {
                        "name": "symbol",
                        "type": "string"
                    },
                    {
                        "name": "bump",
                        "type": "u8"
                    },
                    {
                        "name": "merkleTree",
                        "type": "publicKey"
                    },
                    {
                        "name": "collection",
                        "type": "publicKey"
                    },
                    {
                        "name": "collectionBump",
                        "type": "u8"
                    }
                ]
            }
        },
        {
            "name": "UserAccountV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "accountId",
                        "type": "string"
                    },
                    {
                        "name": "bump",
                        "type": "u8"
                    },
                    {
                        "name": "space",
                        "type": {
                            "array": [
                                "u8",
                                256
                            ]
                        }
                    }
                ]
            }
        },
        {
            "name": "AdminV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "authority",
                        "type": "publicKey"
                    },
                    {
                        "name": "bump",
                        "type": "u8"
                    },
                    {
                        "name": "space",
                        "type": {
                            "array": [
                                "u8",
                                128
                            ]
                        }
                    }
                ]
            }
        }
    ],
    "types": [
        {
            "name": "AddTreeArgsV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "maxDepth",
                        "type": "u32"
                    },
                    {
                        "name": "maxBufferSize",
                        "type": "u32"
                    }
                ]
            }
        },
        {
            "name": "BurnJobRenderArgsV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "accountId",
                        "type": "string"
                    },
                    {
                        "name": "jobs",
                        "type": {
                            "vec": {
                                "defined": "Job"
                            }
                        }
                    }
                ]
            }
        },
        {
            "name": "CreateJobArgsV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "jobId",
                        "type": "string"
                    },
                    {
                        "name": "uri",
                        "type": "string"
                    },
                    {
                        "name": "accountId",
                        "type": "string"
                    }
                ]
            }
        },
        {
            "name": "InitializeMakerArgsV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "updateAuthority",
                        "type": "publicKey"
                    },
                    {
                        "name": "issuingAuthority",
                        "type": "publicKey"
                    },
                    {
                        "name": "name",
                        "type": "string"
                    },
                    {
                        "name": "symbol",
                        "type": "string"
                    },
                    {
                        "name": "metadataUri",
                        "type": "string"
                    }
                ]
            }
        },
        {
            "name": "InitializeUserArgsV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "accountId",
                        "type": "string"
                    }
                ]
            }
        },
        {
            "name": "UpdateMakerArgsV0",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "updateAuthority",
                        "type": {
                            "option": "publicKey"
                        }
                    },
                    {
                        "name": "issuingAuthority",
                        "type": {
                            "option": "publicKey"
                        }
                    }
                ]
            }
        },
        {
            "name": "Job",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "id",
                        "type": "string"
                    },
                    {
                        "name": "renderSpent",
                        "type": "u64"
                    },
                    {
                        "name": "completedAt",
                        "type": "i64"
                    }
                ]
            }
        }
    ],
    "events": [
        {
            "name": "JobCreatedEventV0",
            "fields": [
                {
                    "name": "jobId",
                    "type": "string",
                    "index": false
                },
                {
                    "name": "uri",
                    "type": "string",
                    "index": false
                },
                {
                    "name": "accountId",
                    "type": "string",
                    "index": false
                }
            ]
        },
        {
            "name": "BurnJobRenderEventV0",
            "fields": [
                {
                    "name": "accountId",
                    "type": "string",
                    "index": false
                },
                {
                    "name": "jobs",
                    "type": {
                        "vec": {
                            "defined": "Job"
                        }
                    },
                    "index": false
                }
            ]
        }
    ],
    "errors": [
        {
            "code": 6000,
            "name": "MintAddressMismatch",
            "msg": "MintAddressMismatch"
        },
        {
            "code": 6001,
            "name": "InsufficientEscrowBalance",
            "msg": "InsufficientEscrowBalance"
        },
        {
            "code": 6002,
            "name": "JobAlreadySettled",
            "msg": "JobAlreadySettled"
        },
        {
            "code": 6003,
            "name": "JobNotSettled",
            "msg": "JobNotSettled"
        },
        {
            "code": 6004,
            "name": "NodeEpochNotEnded",
            "msg": "NodeEpochNotEnded"
        },
        {
            "code": 6005,
            "name": "InvalidUuid",
            "msg": "InvalidUuid"
        },
        {
            "code": 6006,
            "name": "NoRewardPoolSet",
            "msg": "NoRewardPoolSet"
        },
        {
            "code": 6007,
            "name": "UnfinishedEpochRewards",
            "msg": "UnfinishedEpochRewards"
        },
        {
            "code": 6008,
            "name": "AuthorityAddressMismatch",
            "msg": "AuthorityAddressMismatch"
        },
        {
            "code": 6009,
            "name": "AccountIdMismatch",
            "msg": "AccountIdMismatch"
        },
        {
            "code": 6010,
            "name": "MissingBurnJobRenderAccount",
            "msg": "MissingBurnJobRenderAccount"
        }
    ]
};
//# sourceMappingURL=constants.js.map