"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderEntityManagerResolvers = exports.renderEntityManagerProgramResolver = void 0;
const spl_utils_1 = require("@render-foundation/spl-utils");
const constants_1 = require("./constants");
const web3_js_1 = require("@solana/web3.js");
const pdas_1 = require("./pdas");
exports.renderEntityManagerProgramResolver = (0, spl_utils_1.resolveIndividual)(({ path }) => __awaiter(void 0, void 0, void 0, function* () {
    if (path[path.length - 1] === 'renderEntityManagerProgram') {
        return constants_1.PROGRAM_ID;
    }
}));
exports.renderEntityManagerResolvers = (0, spl_utils_1.combineResolvers)(spl_utils_1.renderCommonResolver, exports.renderEntityManagerProgramResolver, (0, spl_utils_1.ataResolver)({
    instruction: 'initializeMakerV0',
    account: 'associatedTokenAccount',
    mint: 'collection',
    owner: 'maker',
}), (0, spl_utils_1.resolveIndividual)(({ path, accounts, idlIx, provider, args }) => __awaiter(void 0, void 0, void 0, function* () {
    if (path[path.length - 1] === 'accountEscrow') {
        //const userAccount = get(accounts, [...path.slice(0, path.length - 1)], "userAccount") as PublicKey;
        const renderMint = (0, spl_utils_1.get)(accounts, [
            ...path.slice(0, path.length - 1),
            'renderMint',
        ]);
        return (0, pdas_1.accountEscrowKey)(args[0].accountId, renderMint)[0];
    }
})), (0, spl_utils_1.resolveIndividual)(({ path, accounts, idlIx, provider, args }) => __awaiter(void 0, void 0, void 0, function* () {
    if (path[path.length - 1] === 'userAccount') {
        return (0, pdas_1.userAccountKey)(args[0].accountId)[0];
    }
})), (0, spl_utils_1.resolveIndividual)(({ path, accounts, idlIx, provider, args }) => __awaiter(void 0, void 0, void 0, function* () {
    if (path[path.length - 1] === 'collectionMetadata') {
        const collectionK = (0, spl_utils_1.get)(accounts, [
            ...path.slice(0, path.length - 1),
            'collection',
        ]);
        return (0, pdas_1.collectionMetadataKey)(collectionK)[0];
    }
})), (0, spl_utils_1.resolveIndividual)(({ path, accounts, idlIx, provider, args }) => __awaiter(void 0, void 0, void 0, function* () {
    if (path[path.length - 1] === 'collectionMasterEdition') {
        const collectionK = (0, spl_utils_1.get)(accounts, [
            ...path.slice(0, path.length - 1),
            'collection',
        ]);
        return (0, pdas_1.collectionMasterEditionKey)(collectionK)[0];
    }
})), (0, spl_utils_1.resolveIndividual)(({ path, accounts, idlIx, provider, args }) => __awaiter(void 0, void 0, void 0, function* () {
    if (path[path.length - 1] === 'bubblegumSigner') {
        return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('collection_cpi', 'utf8')], constants_1.MPL_BUBBLEGUM_PROGRAM_ID)[0];
    }
})));
//# sourceMappingURL=resolvers.js.map