import { Program } from "@coral-xyz/anchor";
import { IDL, PROGRAM_ID } from "./constants";
import { renderEntityManagerResolvers } from "./resolvers";
export * from "./constants";
export * from "./pdas";
export * from "./resolvers";
export * from "./instructions";
export async function init(provider, programId = PROGRAM_ID, idl) {
    // TODO: circumventing anchor upgrade idl failure so that idl can be loaded locally
    const resIdl = await (async () => {
        if (typeof idl === "boolean") {
            return IDL;
        }
        if (!idl) {
            return await Program.fetchIdl(programId, provider);
        }
        return idl;
    })();
    const p = new Program(resIdl, programId, provider, undefined, () => renderEntityManagerResolvers);
    return p;
}
//# sourceMappingURL=index.js.map