import { PublicKey } from "@solana/web3.js";
import { PROGRAM_ID, MPL_TOKEN_METADATA_PROGRAM_ID, RENDER_MINT } from "./constants";
export function makerKey(name, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("maker", "utf-8"),
        Buffer.from(name, "utf-8"),
    ], programId);
}
export function collectionMasterEditionKey(collection, tokenMetadataProgram = MPL_TOKEN_METADATA_PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("metadata", "utf-8"),
        tokenMetadataProgram.toBuffer(),
        collection.toBuffer(),
        Buffer.from("edition", "utf-8"),
    ], tokenMetadataProgram);
}
export function collectionMetadataKey(collection, tokenMetadataProgram = MPL_TOKEN_METADATA_PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("metadata", "utf-8"),
        tokenMetadataProgram.toBuffer(),
        collection.toBuffer(),
    ], tokenMetadataProgram);
}
export function collectionKey(maker, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("collection", "utf-8"),
        maker.toBuffer(),
    ], programId);
}
export function treeConfigKey(merkleTree, programId = new PublicKey('BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY')) {
    return PublicKey.findProgramAddressSync([
        merkleTree.toBuffer()
    ], programId);
}
export function accountEscrowKey(uuid, renderMint = RENDER_MINT, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("job_spend_escrow", "utf-8"),
        Buffer.from(uuid.replace(/-/g, ""), "hex"),
        renderMint.toBuffer()
    ], programId);
}
export function userAccountKey(uuid, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("user_account", "utf-8"),
        Buffer.from(uuid.replace(/-/g, ""), "hex")
    ], programId);
}
//# sourceMappingURL=pdas.js.map