import { Program } from '@coral-xyz/anchor';
import { Connection, PublicKey, TransactionInstruction } from '@solana/web3.js';
import { RenderEntityManager } from '@render-foundation/idls/lib/types/render_entity_manager';
export declare const initializeMakerV0Ix: (program: Program<RenderEntityManager>, args: {
    updateAuthority: PublicKey;
    issuingAuthority?: PublicKey;
    name: string;
    symbol: string;
    metadataUri: string;
}, accts: {
    payer?: PublicKey;
}) => Promise<TransactionInstruction>;
export declare const addTreeV0Ix: (program: Program<RenderEntityManager>, args: {
    maxDepth: number;
    maxBufferSize: number;
    makerName: string;
}, accts: {
    updateAuthority: PublicKey;
    payer?: PublicKey;
    merkleTree: PublicKey;
}) => Promise<TransactionInstruction>;
export declare const initializeUserV0Ix: (program: Program<RenderEntityManager>, { accountId, }: {
    accountId: string;
}, { renderMint, authority, payer, }: {
    authority: PublicKey;
    payer?: PublicKey;
    renderMint?: PublicKey;
}) => Promise<TransactionInstruction>;
export declare const transferToAccountEscrowIx: (conn: Connection, { userId, amount, fromAta, from, mint, decimals, }: {
    userId: string;
    amount: number;
    from: PublicKey;
    fromAta: PublicKey;
    mint?: PublicKey;
    decimals?: number;
}) => Promise<TransactionInstruction>;
export declare const createJobV0Ix: (program: Program<RenderEntityManager>, { accountId, makerName, job, }: {
    makerName: string;
    accountId: string;
    job: {
        id: string;
        uri: string | {
            accessKey: string;
            secretKey: string;
            data: any;
        };
    };
}, accts: {
    issuingAuthority: PublicKey;
    payer?: PublicKey;
    merkleTree: PublicKey;
}) => Promise<TransactionInstruction>;
export declare const burnJobRenderV0Ix: (program: Program<RenderEntityManager>, { accountId, jobs, }: {
    accountId: string;
    jobs: {
        id: string;
        renderSpent: number;
        completedAt: Date;
    }[];
}, accts: {
    authority: PublicKey;
    renderMint: PublicKey;
}) => Promise<TransactionInstruction>;
//# sourceMappingURL=instructions.d.ts.map